package me.filaotou.pokeclear

import com.pixelmonmod.pixelmon.api.registries.PixelmonSpecies
import com.pixelmonmod.pixelmon.entities.pixelmon.PixelmonEntity
import me.fullidle.fiscript.fiscript.Main
import org.bukkit.Bukkit
import org.bukkit.command.Command
import org.bukkit.command.CommandExecutor
import org.bukkit.command.CommandMap
import org.bukkit.command.CommandSender
import org.bukkit.command.PluginCommand
import org.bukkit.configuration.file.YamlConfiguration
import org.bukkit.craftbukkit.v1_16_R3.entity.CraftEntity
import org.bukkit.plugin.Plugin
import org.bukkit.plugin.SimplePluginManager
import static me.filaotou.pokeclear.Data.*

class PokeClear {
    static void main(String[] args) {
        {/**/
            config = YamlConfiguration.loadConfiguration(new File(configPath))
            world = config.getStringList("world")
            unClearDexID = config.getIntegerList("unClearDexID")
            if (config.getString("clearType").equalsIgnoreCase("normal")) {
                normalClear = new NormalClear(plugin)
            } else {
                waitClear = new WaitClear(plugin)
            }
        }
        {/*עָ*/
            regCmd("pokeclear", Arrays.asList("pokeclear"))
            Main.plugin.getCommand("pokeclear").executor = new CMD()
        }
        Bukkit.getScheduler().runTaskAsynchronously(plugin, AD::new)
        for (final def species : PixelmonSpecies.getAll()) {
            if (species.isUltraBeast()) {
                ultrabeasts.add(species.getName())
            } else if (species.isLegendary()) {
                legendaries.add(species.getName())
            }
        }
    }

    static class CMD implements CommandExecutor {
        @Override
        boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
            if (sender.isOp() && args.length == 1 && args[0].equalsIgnoreCase("reload")) {
                config = YamlConfiguration.loadConfiguration(new File(configPath))
                world = config.getStringList("world")
                unClearDexID = config.getIntegerList("unClearDexID")
                if (config.getString("clearType").equalsIgnoreCase("normal")) {
                    normalClear.load()
                } else {
                    waitClear.load()
                }
                sender.sendMessage("")
                Bukkit.getScheduler().runTaskAsynchronously(plugin, AD::new)
            }
            if (sender.isOp() && args.length == 1 && args[0].equalsIgnoreCase("clear")) {
                for (final def bukkitWorld : Bukkit.getServer().getWorlds()) {
                    for (final def entity : bukkitWorld.getEntities()) {
                        def en = ((CraftEntity) entity).getHandle()
                        if (en instanceof PixelmonEntity) {
                            PixelmonEntity pe = (PixelmonEntity) en
                            pe.unloadEntity()
                        }
                    }
                }
                return false
            }
            return false
        }
    }

    /*עָ*/
    static def regCmd(String cmd,List<String> aliases){
        def constructor = PluginCommand.class.getDeclaredConstructor(String.class, Plugin.class)
        constructor.setAccessible(true)
        def pluginCmd = constructor.newInstance(cmd, plugin)
        pluginCmd.setAliases(aliases)
        /*ע*/
        commandMap.register(cmd,pluginCmd)
    }

    static def unRegCmd(String cmd){
        plugin.getCommand(cmd).unregister(commandMap)
    }

    static def getCommandMap(){
        def field = SimplePluginManager.class.getDeclaredField('commandMap')
        field.setAccessible(true)
        def commandMap = field.get(Bukkit.getPluginManager()) as CommandMap
        return commandMap
    }
}