package me.filaotou.pokeclear

import com.pixelmonmod.pixelmon.entities.pixelmon.PixelmonEntity
import me.fullidle.fiscript.fiscript.Main
import org.bukkit.Bukkit
import org.bukkit.configuration.file.FileConfiguration
import org.bukkit.craftbukkit.v1_16_R3.entity.CraftEntity
import org.bukkit.entity.Entity
import org.bukkit.event.Listener
import static me.filaotou.pokeclear.Data.*

class NormalClear implements Listener {
    static void main(String[] args) {
    }

    int time
    boolean le
    boolean ul
    boolean shiny
    boolean boss
    boolean canDeSpawn
    Map<Integer, String> msg = new HashMap()

    NormalClear(Main INSTANCE) {
        INSTANCE.getServer().getPluginManager().registerEvents(this, INSTANCE)
        load()
        INSTANCE.getServer().getScheduler().scheduleSyncRepeatingTask(INSTANCE, () -> {
            if (this.time <= 0) {
                clearPokemon()
                this.time = config.getInt("normal.time")
                return
            }
            this.time--
            if (this.msg.containsKey(this.time) && this.time != 0) {
                Bukkit.getServer().broadcastMessage(this.msg.get(this.time) as String)
            }
        }, 20L, 20L)
        INSTANCE.getLogger().info("ɹģ: NormalClear")
    }

    def load() {
        this.time = config.getInt("normal.time")
        this.le = config.getBoolean("normal.le")
        this.ul = config.getBoolean("normal.ul")
        this.shiny = config.getBoolean("normal.shiny")
        this.boss = config.getBoolean("normal.boss")
        this.canDeSpawn = config.getBoolean("normal.canDeSpawn")
        config.getConfigurationSection("normal.message").getKeys(false).forEach(it -> {
            try {
                this.msg.put(Integer.valueOf(Integer.parseInt(it)), config.getString("normal.message." + it).replace("&", ""))
            } catch (Exception ignored) {
            }
        })
    }

    def clearPokemon() {
        int sum = 0
        for (final def bukkitWorld : Bukkit.getServer().getWorlds()) {
            if (world.contains(bukkitWorld.getName())) {
                for (Entity entity : bukkitWorld.getEntities()) {
                    def en = ((CraftEntity) entity).getHandle()
                    if (en instanceof PixelmonEntity) {
                        PixelmonEntity epm = (PixelmonEntity) en
                        if (this.ul || !ultrabeasts.contains(epm.getPokemon().getSpecies().getName())) {
                            if (this.le || !legendaries.contains(epm.getPokemon().getSpecies().getName())) {
                                if (this.shiny || !epm.getPokemon().isShiny()) {
                                    if (this.boss || !epm.isBossPokemon()) {
                                        System.out.println("ɾ,"+epm.getPokemon().getSpecies().getDex())
                                        if (!unClearDexID.contains(epm.getPokemon().getSpecies().getDex()) && (this.canDeSpawn || !epm.canDespawn)) {
                                            if (!epm.hasOwner() && epm.battleController == null) {
                                                epm.unloadEntity()
                                                sum++
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        Bukkit.getServer().broadcastMessage(this.msg.get(0).replace("%num%", String.valueOf(sum)))
    }
}
