package me.filaotou.pokeclear

import com.pixelmonmod.pixelmon.api.events.spawning.SpawnEvent
import com.pixelmonmod.pixelmon.entities.pixelmon.PixelmonEntity
import me.fullidle.ficore.ficore.common.api.event.ForgeEvent
import me.fullidle.fiscript.fiscript.Main
import org.bukkit.Bukkit
import org.bukkit.craftbukkit.v1_16_R3.entity.CraftEntity
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import static me.filaotou.pokeclear.Data.*

class WaitClear implements Listener {
    static void main(String[] args) {
    }
    int time
    int time_
    int wait
    boolean le
    boolean ul
    boolean shiny
    boolean boss
    boolean canDeSpawn
    Map<Integer, String> msg = new HashMap()
    Map<UUID, Long> waitEntity = new HashMap()
    @EventHandler
    void onSpawn(ForgeEvent event) {
        if (event.getForgeEvent() instanceof SpawnEvent) {
            SpawnEvent e = (SpawnEvent) event.getForgeEvent()
            if (e.isCanceled()) {
                return
            }
            if (e.action.getOrCreateEntity() instanceof PixelmonEntity) {
                PixelmonEntity ep = (PixelmonEntity) e.action.getOrCreateEntity()
                if (!this.boss && ep.isBossPokemon()) {
                    return
                }
                if (!this.shiny && ep.getPokemon().isShiny()) {
                    return
                }
                if (!this.le && legendaries.contains(ep.getPokemon().getSpecies().getName())) {
                    return
                }
                if ((!this.ul && ultrabeasts.contains(ep.getPokemon().getSpecies().getName())) || unClearDexID.contains(ep.getPokemon().getSpecies().getDex())) {
                    return
                }
                this.waitEntity.put(ep.getBukkitEntity().getUniqueId(),System.currentTimeMillis() + (this.wait * 1000L))
            }
        }
    }

    WaitClear(Main INSTANCE) {
        INSTANCE.getServer().getPluginManager().registerEvents(this, INSTANCE)
        load()
        INSTANCE.getServer().getScheduler().scheduleSyncRepeatingTask(INSTANCE, () -> {
            if (this.time <= 0) {
                clearPokemon()
                this.time = this.time_
                return
            }
            this.time--
            if (this.msg.containsKey(this.time) && this.time != 0) {
                Bukkit.getServer().broadcastMessage(this.msg.get(this.time))
            }
        }, 20L, 20L)
        INSTANCE.getLogger().info("ɹģ: WaitClear")
        for (final def bukkitWorld : Bukkit.getServer().getWorlds()) {
            if (world.contains(bukkitWorld.getName())) {
                for (final def entity : bukkitWorld.getEntities()) {
                    def en = ((CraftEntity) entity).getHandle()
                    if (en instanceof PixelmonEntity) {
                        PixelmonEntity epm = (PixelmonEntity) en
                        if (this.ul || !ultrabeasts.contains(epm.getPokemon().getSpecies().getName())) {
                            if (this.le || !legendaries.contains(epm.getPokemon().getSpecies().getName())) {
                                if (this.shiny || !epm.getPokemon().isShiny()) {
                                    if (this.boss || !epm.isBossPokemon()) {
                                        if (!unClearDexID.contains(epm.getPokemon().getSpecies().getDex()) && (this.canDeSpawn || !epm.canDespawn)) {
                                            if (!epm.hasOwner() && epm.battleController == null) {
                                                this.waitEntity.put(epm.getBukkitEntity().getUniqueId(),System.currentTimeMillis() + (this.wait * 1000L))
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    void load() {
        this.time = config.getInt("wait.time.cycle")
        this.time_ = config.getInt("wait.time.cycle")
        this.wait = config.getInt("wait.time.wait")
        this.le = config.getBoolean("wait.le")
        this.ul = config.getBoolean("wait.ul")
        this.shiny = config.getBoolean("wait.shiny")
        this.boss = config.getBoolean("wait.boss")
        this.canDeSpawn = config.getBoolean("wait.canDeSpawn")
        config.getConfigurationSection("wait.message").getKeys(false).forEach(it -> {
            try {
                this.msg.put(Integer.valueOf(Integer.parseInt(it)), config.getString("wait.message." + it).replace("&", ""))
            } catch (Exception ignored) {
            }
        })
    }

    void clearPokemon() {
        int sum = 0
        int wt = 0
        for (final def bukkitWorld : Bukkit.getServer().getWorlds()) {
            if (world.contains(bukkitWorld.getName())) {
                for (final def entity : bukkitWorld.getEntities()) {
                    def en = ((CraftEntity) entity).getHandle()
                    if (en instanceof PixelmonEntity) {
                        PixelmonEntity epm = (PixelmonEntity) en
                        if (this.waitEntity.containsKey(epm.getBukkitEntity().getUniqueId())) {
                            if (System.currentTimeMillis() < this.waitEntity.get(epm.getBukkitEntity().getUniqueId())) {
                                if (System.currentTimeMillis() + (this.time_ * 1000L) > this.waitEntity.get(epm.getBukkitEntity().getUniqueId())) {
                                    wt++
                                }
                            } else if (!epm.hasOwner() && epm.battleController == null) {
                                epm.unloadEntity()
                                sum++
                            }
                        }
                    }
                }
            }
        }
        Bukkit.getServer().broadcastMessage(this.msg.get(0).replace("%num%", String.valueOf(sum)).replace("%wait%", String.valueOf(wt)))
    }
}